/// Ejemplo del Tutorial de Colision
/// theDarkDesigns (c) 2003
/// Wolfgang of Dade
/// vertexar@yahoo.com
/// sale con F1

#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <GL\glut.h>
#include <GL\glaux.h>		
#include "main.h"

#pragma comment( lib, "opengl32.lib" )							// Search For OpenGL32.lib While Linking
#pragma comment( lib, "glaux.lib" )							// Search For OpenGL32.lib While Linking
#pragma comment( lib, "glu32.lib" )								// Search For GLu32.lib While Linking
#pragma comment( lib, "winmm.lib" )								// Search For WinMM Library While Linking

char key_left,key_right,key_up,key_down, key_w;
char key_home,key_end,key_pageup,key_pagedown;
float Time_Elapsed , Time_Scale,Last_Time,Current_Time;
float fps,tLast,i;
float b_width = 16; //Ancho en pixels del bloque
float b_height = 15; //Alto en pixels del bloque
const MAP_HEIGHT =16;//Alto en bloques del mapa
const MAP_WIDTH =20; //Ancho en bloques del mapa
char mapa[MAP_HEIGHT][MAP_WIDTH]; // el mapa!
s_player player; //el jugador principal
point2f o_center; //el centro de los cuadraditos usados en la colisin
int m_columna=0; //columnas desplazadas del mapa
int m_fila=0;//filas desplazadas del mapa
point2f m_desp={0,0}; //pixels desplazadas del mapa
UINT g_Texture[5]; //los identificadores de las texturas

void drawQuad(float x, float y, float width,float height);
void drawCollisionDetectionBlocks(void);
void drawBackground(void);

void drawQuad(float x, float y, float width,float height)
{
	height= height*(2.0/240.0);
	width=  width*(2.0/320.0);
	x = ((x)/160)-1;
	y = -(((y)/120)-1)-height;

	glBegin(GL_QUADS);
	glTexCoord2f(0,0);
	glVertex3f(x		,y		,0);
	glTexCoord2f(.03f,0);
	glVertex3f(x+width	,y		,0);
	glTexCoord2f(.03f,.03f);
	glVertex3f(x+width	,y+height,0);
	glTexCoord2f(0,.03f);
	glVertex3f(x		,y+height,0);
	glEnd();

}

void init(void)
{
	Last_Time=timeGetTime();
	Time_Scale=0.001;

	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);				
	glShadeModel(GL_SMOOTH);						
	glClearDepth(1.0f);		
	glEnable(GL_DEPTH_TEST);
	glDepthFunc( GL_LEQUAL );
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	
    glMatrixMode(GL_PROJECTION);
    gluOrtho2D(0, 0,0, 0); 
	glMatrixMode(GL_MODELVIEW);
    //glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
	glEnable(GL_TEXTURE_2D);
	

	//cargamos el mapa del archivo
	FILE *fp;
	if((fp=fopen("mapas\\level01.txt", "r"))==NULL) {printf("No se ha podido abrir el mapa.\n");exit(1);};
	for(int L=0;L<MAP_HEIGHT;L++)
	{
	fscanf(fp,"%s\n", mapa[L]);
	printf("%s\n",mapa[L]);
	}

	//seteamos las carateristicas del jugador
	player.pos.x = 60;
	player.pos.y = 100;
	player.speed =1;

}


void reshape(int w, int h)
{
	if (!h) return;
	glViewport(0, 0,  (GLsizei) w, (GLsizei) h);
   
}


void Display(void)
{
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	
	// dibujamos el background
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, g_Texture[0]);
//	drawBackground();

	glDisable(GL_TEXTURE_2D);
	//dibujamos el mapa.
	glBindTexture(GL_TEXTURE_2D, g_Texture[1]);
	for (int x=0; x<MAP_WIDTH;x++)
	{
		for(int y=0; y<MAP_HEIGHT; y++)
		{
			if(mapa[y][x]!= '0') glColor3f(1.0,1.0,1.0);
			if(mapa[y][x]== '0') glColor3f(.5,.5,.5);
			
			
			drawQuad(x*b_width,y*b_height,b_width,b_height);	
			}
		}
	
	
	// dibujamos el jugador
	
	glDisable(GL_TEXTURE_2D);
	glColor3f(1,0,1); //azul
	drawQuad(player.pos.x, player.pos.y,b_width,b_height);

	// dibujamos bloques de la colisin
//	drawCollisionDetectionBlocks();

	// dibujamos el bloque correspondiente al jugador.
	glColor3f(0,1,0); //verde
//	drawQuad(player.in_matrix.x*b_width ,player.in_matrix.y*b_height,b_width,b_height);
	
	
	glutSwapBuffers();

}

void Idle(void)
{
 	// la verdad no se que hace esto che.
	Current_Time=timeGetTime();
	Time_Elapsed=( Current_Time - Last_Time ) * Time_Scale;
	Last_Time=Current_Time; 

	//Calculamos el Frame Rate
	if((timeGetTime()/1000)-tLast>1) 
	{
		fps=i;
		tLast=timeGetTime()/1000;
		i=0;
	}
	i++;

	// seteamos las variables de desplazamiento a cero
	player.p_dX=0;
	player.p_dY=0;

	// dependiendo de lo que apretemos cambiamos los desplazamientos
	if(key_left==1)  player.p_dX=-player.speed;
	if(key_right==1) player.p_dX=+player.speed;
	if(key_up==1)	 player.p_dY=-player.speed;
	if(key_down==1)	 player.p_dY=+player.speed;

	//calculamos el centro del jugador
	player.center.x=player.pos.x+b_width/2;
	player.center.y=player.pos.y+b_height/2;

	//calculamos la posicion en la matrix del jugador
	player.in_matrix.x = (player.center.x/b_width);
	player.in_matrix.y = (player.center.y/b_height);

	//calculamos los bloques lindantes al jugador para la colisin
	player.data_block[0]._pos.x= player.in_matrix.x-1;	player.data_block[0]._pos.y= player.in_matrix.y+1;
	player.data_block[1]._pos.x= player.in_matrix.x+0;	player.data_block[1]._pos.y= player.in_matrix.y+1;
	player.data_block[2]._pos.x= player.in_matrix.x+1;	player.data_block[2]._pos.y= player.in_matrix.y+1;
	player.data_block[3]._pos.x= player.in_matrix.x-1;	player.data_block[3]._pos.y= player.in_matrix.y+0;
	player.data_block[4]._pos.x= player.in_matrix.x+1;	player.data_block[4]._pos.y= player.in_matrix.y+0;
	player.data_block[5]._pos.x= player.in_matrix.x-1;	player.data_block[5]._pos.y= player.in_matrix.y-1;
	player.data_block[6]._pos.x= player.in_matrix.x+0;	player.data_block[6]._pos.y= player.in_matrix.y-1;
	player.data_block[7]._pos.x= player.in_matrix.x+1;	player.data_block[7]._pos.y= player.in_matrix.y-1;

	// chequeo de colisin
	for (int t=0;t<8;t++)
	{
	  if (mapa[player.data_block[t]._pos.y][player.data_block[t]._pos.x] !='0')
	  {
		
		// adquirimos el centro del bloque de colision en cuestin
		o_center.x=((player.data_block[t]._pos.x)*b_width)+b_width/2;
		o_center.y=((player.data_block[t]._pos.y)*b_height)+b_height/2;
		
		//si va a chocar en general
		if ((fabs(o_center.x - player.center.x- player.p_dX)<b_width) 
		&&(fabs(o_center.y - player.center.y-player.p_dY )<b_height))
		{

		// si yendo para arriba o abajo en particular va a chocar
		if ((fabs(o_center.x - player.center.x)<b_width) 
			&&(fabs(o_center.y - player.center.y-player.p_dY )<b_height))	
			{			
				//baja
				if(player.p_dY>0) player.pos.y =o_center.y-b_height-b_height/2;	
				// sube
				if(player.p_dY<0) player.pos.y=o_center.y+b_height/2;	
				player.p_dY =0;
			}

		// si yendo para los costados en particular va a chocar
		if ((fabs(o_center.x - player.center.x-player.p_dX)<b_width) 
			&&(fabs(o_center.y - player.center.y)<b_height))	
			{
				//derecha
				if(player.p_dX>0) player.pos.x=o_center.x-(b_width+b_width/2);
				//izquierda
				if(player.p_dX<0) player.pos.x=o_center.x+b_width/2;
				player.p_dX =0;

			}
		}
		
	  }
	}


	//sumamos los desplazamientos a la posicion una vez calculada la colision;
	player.pos.x+=player.p_dX;
	player.pos.y+=player.p_dY;

	glutPostRedisplay();
}

void pressKey(int key, int x, int y) {

	switch (key) {
		case GLUT_KEY_PAGE_UP: key_pageup=1;break;
		case GLUT_KEY_PAGE_DOWN: key_pagedown=1;break;
		case GLUT_KEY_HOME: key_home=1;break;
		case GLUT_KEY_END: key_end=1;break;
		case GLUT_KEY_LEFT : key_left=1;break;
		case GLUT_KEY_RIGHT : key_right=1;break;
		case GLUT_KEY_UP : key_up=1;break;
		case GLUT_KEY_DOWN : key_down=1;break;
		case GLUT_KEY_INSERT : key_w=1;break; 
		case GLUT_KEY_F1	: exit(1);break;

	}
}

void releaseKey(int key, int x, int y) {

	switch (key) {
		case GLUT_KEY_LEFT : key_left=0;break;
		case GLUT_KEY_RIGHT : key_right=0;break;
		case GLUT_KEY_UP : key_up=0;break;
		case GLUT_KEY_DOWN : key_down=0;break;
		case GLUT_KEY_INSERT	: key_w=0;break; 
		case GLUT_KEY_PAGE_UP: key_pageup=0;break;
		case GLUT_KEY_PAGE_DOWN: key_pagedown=0;break;
		case GLUT_KEY_HOME: key_home=0;break;
		case GLUT_KEY_END: key_end=0;break;
		
	}
}

int main(int argc, char **argv)
{
 glutInit(&argc, argv);
 glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
 glutInitWindowSize(320,240);
 glutCreateWindow("main menu");
 init();
 glutFullScreen();	
 glutDisplayFunc(Display);
 glutReshapeFunc(reshape);
 glutSpecialFunc(pressKey);
 glutSpecialUpFunc(releaseKey);
 glutIdleFunc(Idle);
 glutMainLoop();
 
 return 0;             
}


void drawCollisionDetectionBlocks(void)
{
	glColor3f(0,1,1);
	point2f o_center;
	for (int t=0;t<8;t++)
	{
		
		o_center.x=((player.data_block[t]._pos.x)*b_width)+b_width/2;
		o_center.y=((player.data_block[t]._pos.y)*b_height)+b_height/2;
		drawQuad(player.data_block[t]._pos.x*b_width,player.data_block[t]._pos.y*b_height,b_width,b_height);	
		drawQuad(o_center.x ,o_center.y,1,1);	
	}
}

void drawBackground(void)
{
	glColor3f(1,1,1);
	glBindTexture(GL_TEXTURE_2D, g_Texture[0]);
	glBegin(GL_QUADS);
		glTexCoord2f(0,0);
		glVertex3f(-1,-1,0);
		glTexCoord2f(1,0);
		glVertex3f(1,-1,0);
		glTexCoord2f(1,1);
		glVertex3f(1,1,0);
		glTexCoord2f(0,1);
		glVertex3f(-1,1,0);
	glEnd();
}